/*!
  * Ender: open module JavaScript framework (client-lib)
  * copyright Dustin Diaz & Jacob Thornton 2011 (@ded @fat)
  * http://ender.no.de
  * License MIT
  */
(function (context) {
  "use strict";

  // a global object for node.js module compatiblity
  // ============================================

  context.global = context;

  // Implements simple module system
  // losely based on CommonJS Modules spec v1.1.1
  // ============================================

  var modules = {}
    ;

  function require(identifier) {
    // modules can be required from ender's build system, or found on the window
    var module = modules[identifier] || window[identifier];
    if (!module) throw new Error("Requested module '" + identifier + "' has not been defined.");
    return module;
  }

  function provide(name, what) {
    return (modules[name] = what);
  }

  context.provide = provide;
  context.require = require;
}(this));
